
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )

include('shared.lua')

/*---------------------------------------------------------
   Name: Initialize
---------------------------------------------------------*/
function ENT:Initialize()

	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS )
	self.Entity:SetSolid( SOLID_VPHYSICS )
	
	local phys = self.Entity:GetPhysicsObject()
	
	if (phys:IsValid()) then
		phys:Wake()
	end
	
	local max = self.Entity:OBBMaxs()
	local min = self.Entity:OBBMins()
	
	self.ThrustOffset 	= Vector( 0, 0, max.z )
	self.ThrustOffsetR 	= Vector( 0, 0, min.z )
	self.ForceAngle		= self.ThrustOffset:GetNormalized() * -1
	
	self:SetForce( 2000 )

	self:SetOffset( self.ThrustOffset )
	self.Entity:StartMotionController()
	
	self:Switch( false )
	
end

function ENT:Think()
	if (!self:IsOn()) then return end
	
	local waterEnt = ents.Create("water_projectile")
	waterEnt:SetPos(self.Entity:GetPos() + self.Entity:GetUp() * 16)
	waterEnt:Spawn()
	waterEnt:SetNetworkedInt("r",self.Entity:GetNetworkedInt( "r" ))
	waterEnt:SetNetworkedInt("g",self.Entity:GetNetworkedInt( "g" ))
	waterEnt:SetNetworkedInt("b",self.Entity:GetNetworkedInt( "b" ))
	waterEnt:SetNetworkedInt("a",self.Entity:GetNetworkedInt( "a" ))
	waterEnt:SetNetworkedInt("viscosity",self.Entity:GetNetworkedInt( "viscosity" ))
	waterEnt:SetNetworkedInt("player",self.Entity:GetNetworkedInt( "player" ))
	if (!self:GetCollide()) then
		waterEnt:SetCollisionGroup( 4 )
	end
	
	local phys = waterEnt:GetPhysicsObject()
	phys:ApplyForceCenter( self.Entity:GetUp() * (self.Entity:GetNetworkedInt( "forcemul" ) * 3) )
	
	self.Entity:NextThink(CurTime() + 0.1)
	return true
end

/*---------------------------------------------------------
   Name: OnRemove
---------------------------------------------------------*/
function ENT:OnRemove()

end

function ENT:SetForce( force )

	self.Entity:SetNetworkedInt( "forcemul", force )
	
end

function ENT:SetPlayer( ply )

	self.Entity:SetNetworkedInt( "player", ply )
	
end

function ENT:SetViscosity( viscosity )

	self.Entity:SetNetworkedInt( "viscosity", viscosity )
	
end

function ENT:SetCollide( collide )

	self.Entity:SetNetworkedInt( "collide", collide )
	
end

function ENT:SetColor( r, g, b, a )

	self.Entity:SetNetworkedInt( "r", r )
	self.Entity:SetNetworkedInt( "g", g )
	self.Entity:SetNetworkedInt( "b", b )
	self.Entity:SetNetworkedInt( "a", a )
	
	self:SetOverlayText( "Viscosity: " .. tostring(self.Entity:GetNetworkedInt("viscosity")) .. "\n"
						.. "Force: " .. tostring(self.Entity:GetNetworkedInt( "forcemul")) .. "\n"
						.. "Color: " .. tostring(self.Entity:GetNetworkedInt("r"))
						.. ", " .. tostring(self.Entity:GetNetworkedInt("g"))
						.. ", " .. tostring(self.Entity:GetNetworkedInt("b"))
						.. ", " .. tostring(self.Entity:GetNetworkedInt("a")) 		
						)
	
end
/*---------------------------------------------------------
   Called when keypad key is pressed
---------------------------------------------------------*/
function ENT:InputActivate( mul )

	if ( self:GetToggle() ) then 
	
		return self:Switch( !self:IsOn(), mul )
	
	end

	return self:Switch( true, mul )
	
end

/*---------------------------------------------------------
   Called when keypad key is released
---------------------------------------------------------*/
function ENT:InputDeactivate( mul )

	if ( self:GetToggle() ) then return true end
	
	return self:Switch( false, mul )
	
end

/*---------------------------------------------------------
   Name: Use
---------------------------------------------------------*/
function ENT:Use( activator, caller )
end

/*---------------------------------------------------------
   Name: Simulate
---------------------------------------------------------*/
function ENT:PhysicsSimulate( phys, deltatime )

	if (!self:IsOn()) then return SIM_NOTHING end
	
	local ForceAngle, ForceLinear = self.ForceAngle, self.ForceLinear

	return ForceAngle, ForceLinear, SIM_NOTHING // SIM_LOCAL_ACCELERATION
	
end

/*---------------------------------------------------------
   Switch thruster on or off
---------------------------------------------------------*/
function ENT:Switch( on, mul )
	
	if (!self.Entity:IsValid()) then return false end
	
	self:SetOn( on )
	
	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
	end
	
	return true
	
end

/*---------------------------------------------------------
   Sets whether this is a toggle thruster or not
---------------------------------------------------------*/
function ENT:SetToggle(tog)
	self.Toggle = tog
end

function ENT:GetToggle()
	return self.Toggle
end

/*---------------------------------------------------------
   Sets whether water will collide or not
---------------------------------------------------------*/
function ENT:SetCollide(col)
	self.Collide = col
end

function ENT:GetCollide()
	return self.Collide
end


/*---------------------------------------------------------
   Numpad control functions
   These are layed out like this so it'll all get saved properly
---------------------------------------------------------*/
local function On( pl, ent, mul )
	if (!ent:IsValid()) then return false end
	return ent:GetTable():InputActivate( mul )
end

local function Off( pl, ent, mul )
	if (!ent:IsValid()) then return false end
	return ent:GetTable():InputDeactivate( mul )
end

// register numpad functions
numpad.Register( "Wind_On", On )
numpad.Register( "Wind_Off", Off )

