
include('shared.lua')

local waterMat = Material( "sprites/water_proj" )
local waterMat2 = Material( "sprites/water_proj_norm"  )
local waterMat3 = Material( "sprites/water_proj2" )

/*---------------------------------------------------------
   Name: Initialize
---------------------------------------------------------*/
function ENT:Initialize()
	self.face = math.random(-90,90)
	self.Color = Color( 200, 200, 200, 200 )
end


/*---------------------------------------------------------
   Name: DrawPre
---------------------------------------------------------*/
function ENT:Draw()
	
	local pos = self.Entity:GetPos()
	local vel = self.Entity:GetVelocity()
	local mag = self.Entity:GetNetworkedInt( "Magnitude" )
	local color = Color(self.Entity:GetNetworkedInt( "r" ), 
						self.Entity:GetNetworkedInt( "g" ), 
						self.Entity:GetNetworkedInt( "b" ), 
						self.Entity:GetNetworkedInt( "a" ))
	
	render.SetMaterial( waterMat3 )
	
	stage = 0 // -- WATER IS RELAXED
	if vel.x > 150 then 
		stage = 2 // -- WATER IS SPEEDING
	end
	if vel.y > 150 then
		stage = 2
	end
	if vel.z > 150 then
		stage = 2
	end
	
	if vel.x < -150 then 
		stage = 2
	end
	if vel.y < -150 then
		stage = 2
	end
	if vel.z < -150 then
		stage = 2
	end

	if stage != 2 then
		if vel.x > 50 then 
			stage = 1 // --WATER IS MOVING SLOWLY
		end
		if vel.y > 50 then
			stage = 1
		end
		if vel.z > 50 then
			stage = 1
		end
		
		if vel.x < -50 then 
			stage = 1
		end
		if vel.y < -50 then
			stage = 1
		end
		if vel.z < -50 then
			stage = 1
		end
	end
	
	if stage == 2 then
		for i = 1, 10 do
	
			local col = Color( self.Color.r, self.Color.g, self.Color.b, 255 / i )
			render.DrawSprite( pos + vel*(i*-0.005), 12 * (mag / 2), 12 * (mag / 2), col )
		
		end
	elseif stage == 1 then
		render.SetMaterial( waterMat3 )
		render.DrawQuadEasy( pos + Vector(0,0,-1),
							Vector(0,0,self.face):GetNormalized(),
							12 * (mag / 2), 12 * (mag / 2),
							Color( 150, 150, 150, 200 ),
							2000 )
	else
		render.SetMaterial( waterMat )
		render.DrawQuadEasy( pos + Vector(0,0,-2),
						Vector(0,0,90):GetNormalized(),
						12 * (mag / 2), 12 * (mag / 2),
						color,
						80 )
						
		waterMat2:SetMaterialFloat( "$refractamount", 0.02 )
		render.SetMaterial( waterMat2 )
		render.UpdateRefractTexture()
		render.DrawQuadEasy( pos + Vector(0,0,-2),
						Vector(0,0,90):GetNormalized(),
						12 * (mag / 2), 12 * (mag / 2),
						Color( 255, 255, 255, 10 ),
						10 )
	end
end
