
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )


// This is the spawn function. It's called when a client calls the entity to be spawned.
// If you want to make your SENT spawnable you need one of these functions to properly create the entity
//
// ply is the name of the player that is spawning it
// tr is the trace from the player's eyes 
//

function ENT:SpawnFunction( ply, tr )

	if ( !tr.Hit ) then return end
	
	local SpawnPos = tr.HitPos + tr.HitNormal * 16
	
	local ent = ents.Create( "water_projectile" )
		ent:SetPos( SpawnPos )
	ent:Spawn()
	ent:Activate()
	
	return ent
	
end


/*---------------------------------------------------------
   Name: Initialize
---------------------------------------------------------*/
function ENT:Initialize()

	self.Entity:SetModel( "models/Combine_Helicopter/helicopter_bomb01.mdl" )
	self.Entity:DrawShadow(false)
	self.Entity:PhysicsInitSphere( 5 )
	
	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
		phys:SetMass( 100 )
	end
	
	//construct.SetPhysProp( self.Entity:GetNetworkedInt( "player" ), self.Entity, 0, true,  true, 50, nil, nil, nil, nil, nil, "ice" ) 
	
	self.Entity:SetCollisionBounds( Vector( -5, -5, -5 ), Vector( 5, 5, 5 ) )
	self.Entity:SetNetworkedInt("Magnitude",1)
end

function ENT:Think()
    if self.Entity:WaterLevel() != 0 then
        self.Entity:Remove()
    end
end 

/*--------------------------------------------------------
   Name: PhysicsCollide
---------------------------------------------------------*/
function ENT:PhysicsCollide( data, physobj )

	if (data.Speed > 80 && data.DeltaTime > 0.2 ) then
		local LastSpeed = data.OurOldVelocity
		local TargetVelocity = LastSpeed / 10
		physobj:SetVelocity( TargetVelocity )
		
		local effectdata = EffectData()
		effectdata:SetOrigin( self.Entity:GetPos() )
		effectdata:SetNormal( Vector(0,0,0) )
		effectdata:SetRadius( 8 )
		effectdata:SetScale( 3 )
		util.Effect( "watersplash", effectdata )
	end	
end

/*---------------------------------------------------------
   Name: OnTakeDamage
---------------------------------------------------------*/
function ENT:OnTakeDamage( dmginfo )

	// React physically when shot/getting blown
	local effectdata = EffectData()
		effectdata:SetOrigin( self.Entity:GetPos() )
		effectdata:SetNormal( Vector(0,0,0) )
		effectdata:SetRadius( 8 )
		effectdata:SetScale( 3 )
		util.Effect( "watersplash", effectdata )
	self.Entity:TakePhysicsDamage( dmginfo )
	
end


/*---------------------------------------------------------
   Name: Use
---------------------------------------------------------*/
function ENT:Use( activator, caller )

	self.Entity:Remove()
	
	if ( activator:IsPlayer() ) then
	
		// Give the collecting player some free health
		local health = activator:Health()
		activator:SetHealth( health + 1 )
		
	end

end

